/*
  AutoMatrix.h

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#ifndef __AUTO_MATRIX_H__
#define __AUTO_MATRIX_H__

#include <stdlib.h>

class AutoMatrix {
 public:
  //  AutoMatrix();
  
  int Rows() { return rows; }
  int Cols() { return cols; }
  double* GetMatrix() { return tempMatrix; }
  
  void Print() {
    Print(tempMatrix);
  }

  void Print(double *matrix) {
    for (int row = 0; row < rows; row++) {
      printf("|  ");
      for (int col = 0; col < cols; col++) {
	printf("%10.3lf ", *(matrix + row * cols + col));
      }
      printf("  |\n");
    }
  }
  
 protected:
  int rows, cols;
  double *tempMatrix, *templateMatrix;
 
  void CopySubmatrix(double *src, 
 		     int srcrows, int srccols,
 		     int destrow, int destcol) {
    for (int srcrow = 0; srcrow < srcrows; srcrow++) {
      for (int srccol = 0; srccol < srccols; srccol++) {
 	tempMatrix[cols*(destrow + srcrow) + (destcol + srccol)] = *src++;
      }
    }
  }
  
};

#endif
