function [mean, covar] = calc_imu_stats(logfile)

fid = fopen(logfile, 'r');

if (fid == -1) 
  error('Could not open log file');
end

[values, count] = fscanf(fid, '%lf');

readings = reshape(values,10,[])';

reading_count = size(readings,1);

mean = (sum(readings(:,2:4)) / reading_count)';

covar = zeros(3,3);

for i = 1:reading_count
  accel = readings(i,2:4)';
  deviation = accel - mean
  covar = covar + deviation * deviation';
end

covar = covar / reading_count;
   