/*
  lagr/DeviationLogger.h

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#ifndef __VDEVIATION_LOG_H__
#define __VDEVIATION_LOG_H__

#include <stdio.h>
#include <assert.h>
#include <gsl/gsl_cblas.h>
#include <string.h>

#include "../ModelMatrices.h"

#define MAX_STATE_DIM 20

class VelDeviationLogger {
 public:
  DeviationLogger(char *fname, int state_dim) {
    log = fopen(fname, "w");
    assert(log != NULL);
    stateDim = state_dim;
  }

  void SetState(double *initial_state) {
    memcpy(state, initial_state, sizeof(double)*stateDim);
  }

  void Update(double *new_state, double *reading) {
    for (int i = 0; i < stateDim; i++) {
      fprintf(log, "%.10lf ", reading[i] - new_state[i]);
    }
    fprintf(log, "\n");
  }

 private:
  FILE *log;
  int stateDim;
};

#endif
