/*
  lagr/MagLogger.h

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include <stdio.h>
#include <assert.h>

#include "../Quaternion.h"

class MagLogger {
 public:
  MagLogger(char *fname) {
    file = fopen(fname, "w");
    assert(file != NULL);
  }

  void Update(Quaternion *quat, double *reading) {
    /*
    double bodymag[3], ffmag[3];
    ffmag[0] = 1.0; ffmag[1] = 0.0; ffmag[2] = 0.0;
    quat->RotateF2B(ffmag, bodymag);
    double estbias[3];
    for (int i = 0; i < 3; i++) {
      estbias[i] = reading[i] - bodymag[i];
    }

    fprintf(file, "%lf %lf %lf\n", estbias[0], estbias[1], estbias[2]);
    fflush(file);
    */

    double *rotf2b = quat->GetMatrixF2B();
    fprintf(file, "%lf %lf %lf %lf 1.0 0.0 0.0\n", 
	    reading[0], rotf2b[0], rotf2b[1], rotf2b[2]);
    fprintf(file, "%lf %lf %lf %lf 0.0 1.0 0.0\n", 
	    reading[1], rotf2b[3], rotf2b[4], rotf2b[5]);
    fprintf(file, "%lf %lf %lf %lf 0.0 0.0 1.0\n", 
	    reading[2], rotf2b[6], rotf2b[7], rotf2b[8]);
    fflush(file);
  }

 private:
  FILE *file;
};
