/*
  lagr/YawLogger.h

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#ifndef __YAW_LOG_H__
#define __YAW_LOG_H__

#include <stdio.h>
#include <assert.h>
#include <math.h>

#include "../Quaternion.h"

class YawLogger {
 public:
  YawLogger(char *fname) {
    log = fopen(fname, "w");
    assert(log != NULL);
  }

  //  void Update(Quaternion *estquat, Quaternion *lagrquat, double *gpsvel) {
  /*
  void Update(Quaternion *estquat, Quaternion *lagrquat, 
	      Quaternion *hackedquat, double *gpsvel) {
    double x_axis[3], x_axis_est[3], x_axis_lagr[3], x_axis_hacked[3];
    x_axis[0] = 1.0; x_axis[1] = 0.0; x_axis[2] = 0.0;

    estquat->RotateB2F(x_axis, x_axis_est);
    lagrquat->RotateB2F(x_axis, x_axis_lagr);
    hackedquat->RotateB2F(x_axis, x_axis_hacked);
    fprintf(log, "%lf %lf %lf %lf\n", 
	    atan2(x_axis_est[1], x_axis_est[0]),
	    atan2(x_axis_lagr[1], x_axis_lagr[0]),
	    atan2(gpsvel[1], gpsvel[0]),
	    atan2(x_axis_hacked[1], x_axis_hacked[0]));
  }
  */

  void Update(Quaternion *estquat, Quaternion *hackedquat, double *gpsvel) {
    double x_axis[3], x_axis_est[3], x_axis_hacked[3];
    x_axis[0] = 1.0; x_axis[1] = 0.0; x_axis[2] = 0.0;

    estquat->RotateB2F(x_axis, x_axis_est);
    hackedquat->RotateB2F(x_axis, x_axis_hacked);
    fprintf(log, "%lf %lf %lf\n", 
	    atan2(x_axis_est[1], x_axis_est[0]),
	    atan2(x_axis_hacked[1], x_axis_hacked[0]),
	    atan2(gpsvel[1], gpsvel[0]));
  }


 private:
  FILE *log;
};

#endif
