function [ regress1, regress2 ] = process_log(fname) 

new_angles = [];

logdata = load(fname);

for angles_i = 1:size(logdata,2)
     angles = smooth_angles(logdata(:,angles_i)');     
     new_angles = [ new_angles, angles' ];
end

dc_level = mean(new_angles(:,1))

for angles_i = 2:size(logdata,2)
  dc_diff = mean(new_angles(:,angles_i)) - dc_level
  new_angles(:,angles_i) = new_angles(:,angles_i) - dc_diff;
end

diff_angles = diff(new_angles);

cov1 = cov(diff_angles(:,1))
cov2 = cov(diff_angles(:,2))
max1 = max(diff_angles(:,1))
max2 = max(diff_angles(:,2))

if (0)
regressexes1 = new_angles(:,1);
regressmat1 = [ regressexes1, ones(size(regressexes1)) ];
end

for angle_i = 1:size(logdata,1)
	delta_angles1(angle_i,1) = angle_min_diff(logdata(angle_i,1), logdata(angle_i,3)) - logdata(angle_i,3);
	delta_angles2(angle_i,1) = angle_min_diff(logdata(angle_i,2), logdata(angle_i,3)) - logdata(angle_i,3);
end

figure(10)
clearplot
hold on
plot(new_angles(:,1),'rx-');
plot(new_angles(:,2),'gx-');
plot(new_angles(:,3),'bx-');

save -ascii 'yaw.log' new_angles;

if(0),
regressexes1 = (1:size(delta_angles1,1)')';
regressmat1 = [ regressexes1, ones(size(delta_angles1,1),1) ];
regress1 = regressmat1 \ delta_angles1;

regressexes2 = (1:size(delta_angles2,1)')';
regressmat2 = [ regressexes2, ones(size(delta_angles2,1),1) ];
regress2 = regressmat2 \ delta_angles2;

rlinewhys1 = regressmat1 * regress1;
rlinewhys2 = regressmat2 * regress2;

figure(11)
clearplot
hold on
plot(delta_angles1, 'rx-');
plot(delta_angles2, 'bx-');

plot(rlinewhys1, 'gx-');
plot(rlinewhys2, 'cx-');
end
