/*
  lagr/plot_lagr_log.cpp

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>

#include "../Quaternion.h"

int main(int argc, char *argv[]) {
  double readings[3], timestamp;
  char type;

  if (argc < 2) {
    printf("usage: plot_lagr_log <log file>\n");
    exit(1);
  }

  FILE *logfile = fopen(argv[1], "r");

  double pos[3], quatarray[4];
  double last_t = 0.0;
  double inityaw = 0.0;
  int counter = 0;
  while (fscanf(logfile, "%lf %c %lf %lf %lf\n", 
		&timestamp, &type, readings, readings + 1, readings + 2) == 5) {

    double delta_t = 0.0;
    if (last_t != 0.0) 
      delta_t = timestamp - last_t; 
    else 
      inityaw = readings[2] - M_PI / 2.0;

    last_t = timestamp;

    //    if (delta_t > 0.0 ) 
    //    usleep(int(0.05*1e6));

    switch (type) {
    case 'Y': {
      double roll = readings[0], pitch = readings[1], yaw = readings[2];
      //      double roll = 0.0, pitch = 0.0, yaw  = readings[2];
      Quaternion quat(roll, pitch, yaw - inityaw);
      //      quat.Invert();
      memcpy(quatarray, quat.GetArray(), sizeof(double)*4);
    }
      break;
    case 'P': {
      usleep(10000);
      memcpy(pos, readings, sizeof(double)*3);
    }
      break;
    }

    printf("1\n");
    printf("%lf %lf %lf %lf %lf %lf %lf\n", 
	   quatarray[0], quatarray[1], quatarray[2], quatarray[3],
	   pos[0], pos[1], pos[2]);

    
    if (counter++ % 30 == 0)
      fprintf(stderr, "P-Z %lf\n", pos[2]);
    fflush(stdout);
  }
}
