/*
  plotting/GPSPGraphic.cpp

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include <math.h>
#include <stdio.h>
#include <string.h>

#include "GPSPGraphic.h"

GPSPGraphic::GPSPGraphic() {
  /*
  listId = glGenLists(1);
  glNewList(listId, GL_COMPILE);

  glPushMatrix();

  

  glPopMatrix();

  glEndList();
  */
  double zeroes[3] = { 0, 0, 0 };
  SetPosErr(zeroes, zeroes);
}

void GPSPGraphic::SetPosErr(double *pos, double *err) {
  memcpy(position, pos, sizeof(double)*3);
  memcpy(errors, err, sizeof(double)*2);
}

void GPSPGraphic::Draw() {
  glColor3d(0.0, 1.0, 1.0);

  glPushMatrix();
  
  glTranslated(position[0], position[1], position[2]);

  glBegin(GL_LINE_STRIP);
  for (double theta = 0.0; theta <= 2 * M_PI; theta += M_PI / 20) {
    glVertex3d(errors[0] * cos(theta), errors[1] * sin(theta), 0);
  }
  glEnd();

  glBegin(GL_LINES);
  glVertex3d(-0.5, 0.0, 0.0);
  glVertex3d(0.5, 0.0, 0.0);
  glVertex3d(0.0, -0.5, 0.0);
  glVertex3d(0.0, 0.5, 0.0);
  glEnd();

  glPopMatrix();
}
