/*
  plotting/GridGraphic.cpp

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include "GridGraphic.h"

GridGraphic::GridGraphic(double span, int count) {
  listId = glGenLists(1);
  glNewList(listId, GL_COMPILE);

  glPushMatrix();

  double spacing = span / count;

  glColor3d(0.0, 1.0, 0.0);

  // xy grid
  glLineWidth(0.5f);
  double lx, ly;
  for (lx = -span / 2.0; lx < span / 2.0; lx += spacing) { 
    glBegin(GL_LINES);
    glVertex3d(lx, -span/2, 0.0);
    glVertex3d(lx, span/2, 0.0);
    glEnd();
  }
  for (ly = -span / 2.0; ly < span / 2.0; ly += spacing) {
    glBegin(GL_LINES);
    glVertex3d(-span/2, ly, 0.0);
    glVertex3d(span/2, ly, 0.0);
    glEnd();
  }

  glPopMatrix();

  glEndList();
}

void GridGraphic::Draw() {
  glPushMatrix();

  glTranslated(xpos, ypos, zpos);
  glCallList(listId);

  glPopMatrix();
}
