/*
  plotting/LocalMapGraphic.cpp

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include <glut.h>

#include "LocalMapGraphic.h"

void LocalMapGraphic::Draw() {
  glPointSize(10.0f);

  for (stringhash_t::iterator hash_it = obstacleMap.begin();
       hash_it != obstacleMap.end();
       hash_it++) {
    double *xyval = hash_it->second;

    glPushMatrix();

    glTranslated(xyval[0], xyval[1], zHeight);

    glBegin(GL_POLYGON);

    if (xyval[2] < 0) {
      glColor4d(0.0, -tanh(xyval[2] / 10.0), 0.0, 0.9);
    } else {
      glColor4d(tanh(xyval[2] / 10.0), 0.0, 0.0, 0.9);
    }
    //    glVertex3d(xyval[0], xyval[1], zHeight);
    
    glVertex3d(-cellSize/2, -cellSize/2, 0.0);
    glVertex3d(-cellSize/2, cellSize/2, 0.0);
    glVertex3d(cellSize/2, cellSize/2, 0.0);
    glVertex3d(cellSize/2, -cellSize/2, 0.0);

    glEnd();

    glPopMatrix();
  }


}
