/*
  plotting/Menu.h

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#ifndef __MENU_H__
#define __MENU_H__

#define MAX_USER_INPUT_BUFFER 255
#define MAX_USER_MESSAGE 1024

typedef enum { UMESS_NONE, UMESS_CAMPOS, UMESS_ARB, UMESS_CENTERCAM, 
	       UMESS_SINGLESTEP, UMESS_PAUSE, UMESS_RESUME, UMESS_EXIT,
	       UMESS_RESET
} user_message_t;

typedef enum { MENU_OFF, MENU_MAIN, MENU_MESSAGE } menu_state_t;
typedef enum { INPUT_ARBCOMMAND, INPUT_CAMPOS } input_state_t;

class Menu {
 public:
  Menu(int width, int height) {
    winWidth = width;
    winHeight = height;

    menuState = MENU_MAIN;
    userInputActive = false;
    userDataEntryPos = 0;
    userDataEntry[0] = 0;
    menuMessageBuffer[0] = 0;
    userMessage[0] = 0;
  };

  user_message_t HandleKeystroke(unsigned char key, int xpos, int ypos);
  char *GetUserMessage() { return userMessage; }
  void Draw();
  void DrawString(const char *pstring, int xpos, int ypos);

  void DispMessage(const char *message);

  void SetWinSize(int w, int h) { winWidth = w; winHeight = h; }

 private:
  int winWidth, winHeight;
  menu_state_t menuState;
  input_state_t inputState;
  bool userInputActive;
  int userDataEntryPos;
  char userDataEntry[MAX_USER_INPUT_BUFFER];
  char menuMessageBuffer[MAX_USER_INPUT_BUFFER];

  char userMessage[MAX_USER_MESSAGE];
  
};

#endif
