/*
  plotting/PathGraphic.cpp

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include "PathGraphic.h"

#include <stdio.h>

PathGraphic::PathGraphic() {
  numPairs = 0;

  sphereQuad = gluNewQuadric();
  gluQuadricDrawStyle(sphereQuad, GLU_LINE);

  listId = glGenLists(1);

  glNewList(listId, GL_COMPILE);

  gluSphere(sphereQuad, 0.5, 10, 5);

  glEndList();
}

void PathGraphic::Draw() {
  glColor4d(1.0, 0.5, 1.0, 0.5);

  glLineWidth(3.0f);

  for (int i = 0; i < numPairs; i++) {
    glPushMatrix();
    glTranslated(points[2*i], points[2*i+1], zHeight);

    /*
    glBegin(GL_POINTS);
    glVertex3d(0.0, 0.0, 0.0);
    glEnd();
    */
    glCallList(listId);

    glPopMatrix();
  }

  glLineWidth(6.0f);

  glBegin(GL_LINE_STRIP);
  for (int i = 0; i < numPairs; i++) {
    glVertex3d(points[2*i], points[2*i+1], zHeight);
  }
  glEnd();
}
