/*
  plotting/PathGraphic.h

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#ifndef __PATH_GRAPHIC_H__
#define __PATH_GRAPHIC_H__

#include <glut.h>
#include <string.h>
#include "GLDrawable.h"

#define MAX_PATH_DISP_POINTS 200

class PathGraphic : public GLDrawable {
 public:
  PathGraphic();
  virtual ~PathGraphic() {
    gluDeleteQuadric(sphereQuad);
  };

  // sets a list of xy pairs
  void SetPath(double z_height, double *inpairs, int numpairs) {
    int points_to_copy =
      (numpairs < MAX_PATH_DISP_POINTS ? numpairs : MAX_PATH_DISP_POINTS);
    numPairs = points_to_copy;
    memcpy(points, inpairs, sizeof(double)*points_to_copy*2);
    zHeight = z_height;
  }

  void Draw();

 private:
  GLuint listId;
  GLUquadric *sphereQuad;
  double points[MAX_PATH_DISP_POINTS*2];
  double zHeight;
  int numPairs;
};

#endif
