/*
  plotting/PlotMessage.cpp

  (C) 2005 Paul Vernaza, <vernaza@stwing.upenn.edu>
*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "PlotMessage.h"

static message_type_data_t Message_Type_Data[] = 
  { { "GPS ", PLOT_GPS },
    { "CGPOSE ", PLOT_POSE },
    { "CLPOSE ", PLOT_LOCALPOSE },
    { "BGPOSE ", PLOT_BASELINEPOSE },
    { "POSE ", PLOT_BASELINEPOSE },
    { "PATH ", PLOT_PATH },
    { "MAP ", PLOT_LOCALMAP },
    { "NUPDATE ", PLOT_IGNORE },
    { "ETIME ", PLOT_IGNORE },
    { "NMSG ", PLOT_IGNORE },
    { "VEL ", PLOT_VEL },
    { "", PLOT_END_OF_LIST } };

// input should be null-terminated
PlotMessage::PlotMessage(char *stringified) {
  //  char messagebuf[MAX_PMESSAGE_AS_STRING];
  double *dbuf = (double*)buf;


  /*
  strncpy(messagebuf, stringified, sizeof(char)*MAX_PMESSAGE_AS_STRING);
  
  if (messagebuf[MAX_PMESSAGE_AS_STRING - 1] != 0) {
    printf("WARNING: PlotMessage too long or non-null-terminated\n");
    messagebuf[MAX_PMESSAGE_AS_STRING - 1] = 0;
  }
  */
  
  char *messdataptr = NULL;

  type = PLOT_UNKNOWN;

  for (int i = 0; Message_Type_Data[i].messtype != PLOT_END_OF_LIST; i++) {
    if (strncmp(Message_Type_Data[i].messageprefix, 
		stringified, 
		strlen(Message_Type_Data[i].messageprefix)) == 0) {
      type = Message_Type_Data[i].messtype;
      messdataptr = 
	stringified + strlen(Message_Type_Data[i].messageprefix);
      break;
    }
  }


  if (type == PLOT_UNKNOWN) {
  /*    
	stringified[5] = 0;
    printf("unknown type of message %s...!\n", stringified);
  */
    dataCount = 0;
    return;
  }

  char curchar = 'a';
  dataCount = 0;

  while (curchar != '\n' && curchar != 0) {
    while (*messdataptr == ' ') messdataptr++; // skip spaces

    dbuf[dataCount++] = strtod(messdataptr, &messdataptr);
    curchar = *messdataptr;
  }
}

