% A = process matrix
% Q = process noise
% B = measurement matrix
% R = measurement noise
function [ new_mean, new_covar ] = KalmanFilter(A, Q, B, R, ...
						mean, covar, ...
						measurement)

measurement_dim = size(covar,1);

P_prime = A * covar * A' + Q;
K = P_prime * B' * inv(B * P_prime * B' + R)
eye_minus_kb = eye(measurement_dim) - K * B
new_covar = eye_minus_kb * P_prime * eye_minus_kb' + K * R * K';
new_mean = A * mean + K * (measurement - B * A * mean);